diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/sta-wifi-mac.h ns-3.40/src/wifi/model/sta-wifi-mac.h
--- ns-3.39/src/wifi/model/sta-wifi-mac.h	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/sta-wifi-mac.h	2023-09-27 13:30:37.914839700 -0700
@@ -162,14 +162,24 @@
      */
     struct ApInfo
     {
+        /**
+         * Information about links to setup
+         */
+        struct SetupLinksInfo
+        {
+            uint8_t localLinkId; ///< local link ID
+            uint8_t apLinkId;    ///< AP link ID
+            Mac48Address bssid;  ///< BSSID
+        };
+
         Mac48Address m_bssid;  ///< BSSID
         Mac48Address m_apAddr; ///< AP MAC address
         double m_snr;          ///< SNR in linear scale
         MgtFrameType m_frame;  ///< The body of the management frame used to update AP info
         WifiScanParams::Channel m_channel; ///< The channel the management frame was received on
         uint8_t m_linkId;                  ///< ID of the link used to communicate with the AP
-        /// list of (local link ID, AP link ID) pairs identifying the links to setup between MLDs
-        std::list<std::pair<uint8_t, uint8_t>> m_setupLinks;
+        std::list<SetupLinksInfo>
+            m_setupLinks; ///< information about the links to setup between MLDs
     };
 
     /**
@@ -247,12 +257,6 @@
     std::set<uint8_t> GetSetupLinkIds() const;
 
     /**
-     * \param linkId the IO of the given link
-     * \return the ID (as set by the AP) of the given link, if the given link has been setup
-     */
-    std::optional<uint8_t> GetApLinkId(uint8_t linkId) const;
-
-    /**
      * Return the association ID.
      *
      * \return the association ID
@@ -291,6 +295,44 @@
     void NotifyChannelSwitching(uint8_t linkId) override;
 
     /**
+     * Notify the MAC that EMLSR mode has changed on the given set of links.
+     *
+     * \param linkIds the IDs of the links that are now EMLSR links (EMLSR mode is disabled
+     *                on other links)
+     */
+    void NotifyEmlsrModeChanged(const std::set<uint8_t>& linkIds);
+
+    /**
+     * \param linkId the ID of the given link
+     * \return whether the EMLSR mode is enabled on the given link
+     */
+    bool IsEmlsrLink(uint8_t linkId) const;
+
+    /**
+     * Notify that the given PHY switched channel to operate on another EMLSR link.
+     *
+     * \param phy the given PHY
+     * \param linkId the ID of the EMLSR link on which the given PHY is operating
+     */
+    void NotifySwitchingEmlsrLink(Ptr<WifiPhy> phy, uint8_t linkId);
+
+    /**
+     * Block transmissions on the given link for the given reason.
+     *
+     * \param linkId the ID of the given link
+     * \param reason the reason for blocking transmissions on the given link
+     */
+    void BlockTxOnLink(uint8_t linkId, WifiQueueBlockedReason reason);
+
+    /**
+     * Unblock transmissions on the given link for the given reason.
+     *
+     * \param linkId the ID of the given link
+     * \param reason the reason for unblocking transmissions on the given link
+     */
+    void UnblockTxOnLink(uint8_t linkId, WifiQueueBlockedReason reason);
+
+    /**
      * Assign a fixed random variable stream number to the random variables
      * used by this model.  Return the number of streams (possibly zero) that
      * have been assigned.
@@ -314,14 +356,13 @@
 
         bool sendAssocReq;                 //!< whether this link is used to send the
                                            //!< Association Request frame
-        std::optional<uint8_t> apLinkId;   //!< ID (as set by the AP) of the link we have
-                                           //!< setup or are setting up
         std::optional<Mac48Address> bssid; //!< BSSID of the AP to associate with over this link
         EventId beaconWatchdog;            //!< beacon watchdog
         Time beaconWatchdogEnd{0};         //!< beacon watchdog end
         WifiPowerManagementMode pmMode{WIFI_PM_ACTIVE}; /**< the current PM mode, if the STA is
                                                              associated, or the PM mode to switch
                                                              to upon association, otherwise */
+        bool emlsrEnabled{false}; //!< whether EMLSR mode is enabled on this link
     };
 
     /**
@@ -332,7 +373,15 @@
      */
     StaLinkEntity& GetLink(uint8_t linkId) const;
 
-  private:
+    /**
+     * Cast the given LinkEntity object to StaLinkEntity.
+     *
+     * \param link the given LinkEntity object
+     * \return a reference to the object casted to StaLinkEntity
+     */
+    StaLinkEntity& GetStaLink(const std::unique_ptr<WifiMac::LinkEntity>& link) const;
+
+  public:
     /**
      * The current MAC state of the STA.
      */
@@ -345,6 +394,7 @@
         REFUSED
     };
 
+  private:
     /**
      * Enable or disable active probing.
      *
@@ -494,6 +544,13 @@
      * \return the Multi-Link Element
      */
     MultiLinkElement GetMultiLinkElement(bool isReassoc, uint8_t linkId) const;
+
+    /**
+     * \param apNegSupport the negotiation type supported by the AP MLD
+     * \return the TID-to-Link Mapping element(s) to include in Association Request frame.
+     */
+    std::vector<TidToLinkMapping> GetTidToLinkMappingElements(uint8_t apNegSupport);
+
     /**
      * Set the current MAC state.
      *
@@ -580,6 +637,11 @@
                                             ///< of the first Probe Response on each channel
     Time m_pmModeSwitchTimeout;             ///< PM mode switch timeout
 
+    /// store the DL TID-to-Link Mapping included in the Association Request frame
+    WifiTidLinkMapping m_dlTidLinkMappingInAssocReq;
+    /// store the UL TID-to-Link Mapping included in the Association Request frame
+    WifiTidLinkMapping m_ulTidLinkMappingInAssocReq;
+
     TracedCallback<Mac48Address> m_assocLogger;             ///< association logger
     TracedCallback<uint8_t, Mac48Address> m_setupCompleted; ///< link setup completed logger
     TracedCallback<Mac48Address> m_deAssocLogger;           ///< disassociation logger
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/supported-rates.cc ns-3.40/src/wifi/model/supported-rates.cc
--- ns-3.39/src/wifi/model/supported-rates.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/supported-rates.cc	2023-09-27 13:30:37.914839700 -0700
@@ -21,6 +21,8 @@
 
 #include "ns3/log.h"
 
+#include <algorithm>
+
 namespace ns3
 {
 
@@ -95,7 +97,7 @@
 {
     NS_LOG_FUNCTION(this << bs);
     NS_ASSERT_MSG(IsBssMembershipSelectorRate(bs) == false, "Invalid rate");
-    uint8_t rate = static_cast<uint8_t>(bs / 500000);
+    auto rate = static_cast<uint8_t>(bs / 500000);
     for (uint8_t i = 0; i < GetNRates(); i++)
     {
         auto& currRate = i < 8 ? rates.m_rates[i] : extendedRates->m_rates[i - 8];
@@ -121,7 +123,7 @@
     NS_ASSERT_MSG(bs == BSS_MEMBERSHIP_SELECTOR_HT_PHY || bs == BSS_MEMBERSHIP_SELECTOR_VHT_PHY ||
                       bs == BSS_MEMBERSHIP_SELECTOR_HE_PHY || bs == BSS_MEMBERSHIP_SELECTOR_EHT_PHY,
                   "Value " << bs << " not a BSS Membership Selector");
-    uint8_t rate = static_cast<uint8_t>(bs / 500000);
+    auto rate = static_cast<uint8_t>(bs / 500000);
     for (std::size_t i = 0; i < rates.m_rates.size(); i++)
     {
         if (rate == rates.m_rates[i])
@@ -158,7 +160,7 @@
 AllSupportedRates::IsSupportedRate(uint64_t bs) const
 {
     NS_LOG_FUNCTION(this << bs);
-    uint8_t rate = static_cast<uint8_t>(bs / 500000);
+    auto rate = static_cast<uint8_t>(bs / 500000);
     for (std::size_t i = 0; i < rates.m_rates.size(); i++)
     {
         if (rate == rates.m_rates[i] || (rate | 0x80) == rates.m_rates[i])
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/txop.cc ns-3.40/src/wifi/model/txop.cc
--- ns-3.39/src/wifi/model/txop.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/txop.cc	2023-09-27 13:30:37.914839700 -0700
@@ -169,15 +169,33 @@
 Txop::LinkEntity&
 Txop::GetLink(uint8_t linkId) const
 {
-    NS_ASSERT(linkId < m_links.size());
-    NS_ASSERT(m_links.at(linkId)); // check that the pointer owns an object
-    return *m_links.at(linkId);
+    auto it = m_links.find(linkId);
+    NS_ASSERT(it != m_links.cend());
+    NS_ASSERT(it->second); // check that the pointer owns an object
+    return *it->second;
 }
 
-uint8_t
-Txop::GetNLinks() const
+const std::map<uint8_t, std::unique_ptr<Txop::LinkEntity>>&
+Txop::GetLinks() const
+{
+    return m_links;
+}
+
+void
+Txop::SwapLinks(std::map<uint8_t, uint8_t> links)
 {
-    return m_links.size();
+    NS_LOG_FUNCTION(this);
+
+    decltype(m_links) tmp;
+    tmp.swap(m_links); // move all links to temporary map
+    for (const auto& [from, to] : links)
+    {
+        auto nh = tmp.extract(from);
+        nh.key() = to;
+        m_links.insert(std::move(nh));
+    }
+    // move links remaining in tmp to m_links
+    m_links.merge(tmp);
 }
 
 void
@@ -192,12 +210,9 @@
 {
     NS_LOG_FUNCTION(this << mac);
     m_mac = mac;
-    m_links.resize(m_mac->GetNLinks());
-    uint8_t linkId = 0;
-    for (auto& link : m_links)
+    for (const auto linkId : m_mac->GetLinkIds())
     {
-        link = CreateLinkEntity();
-        link->id = linkId++;
+        m_links.emplace(linkId, CreateLinkEntity());
     }
 }
 
@@ -229,9 +244,10 @@
 Txop::SetMinCws(std::vector<uint32_t> minCws)
 {
     NS_ABORT_IF(minCws.size() != m_links.size());
-    for (std::size_t linkId = 0; linkId < minCws.size(); linkId++)
+    std::size_t i = 0;
+    for (const auto& [id, link] : m_links)
     {
-        SetMinCw(minCws[linkId], linkId);
+        SetMinCw(minCws[i++], id);
     }
 }
 
@@ -258,9 +274,10 @@
 Txop::SetMaxCws(std::vector<uint32_t> maxCws)
 {
     NS_ABORT_IF(maxCws.size() != m_links.size());
-    for (std::size_t linkId = 0; linkId < maxCws.size(); linkId++)
+    std::size_t i = 0;
+    for (const auto& [id, link] : m_links)
     {
-        SetMaxCw(maxCws[linkId], linkId);
+        SetMaxCw(maxCws[i++], id);
     }
 }
 
@@ -355,9 +372,10 @@
 Txop::SetAifsns(std::vector<uint8_t> aifsns)
 {
     NS_ABORT_IF(aifsns.size() != m_links.size());
-    for (std::size_t linkId = 0; linkId < aifsns.size(); linkId++)
+    std::size_t i = 0;
+    for (const auto& [id, link] : m_links)
     {
-        SetAifsn(aifsns[linkId], linkId);
+        SetAifsn(aifsns[i++], id);
     }
 }
 
@@ -381,9 +399,10 @@
                     "The size of the given vector (" << txopLimits.size()
                                                      << ") does not match the number of links ("
                                                      << m_links.size() << ")");
-    for (std::size_t linkId = 0; linkId < txopLimits.size(); linkId++)
+    std::size_t i = 0;
+    for (const auto& [id, link] : m_links)
     {
-        SetTxopLimit(txopLimits[linkId], linkId);
+        SetTxopLimit(txopLimits[i++], id);
     }
 }
 
@@ -406,9 +425,10 @@
 Txop::GetMinCws() const
 {
     std::vector<uint32_t> ret;
-    for (std::size_t linkId = 0; linkId < m_links.size(); linkId++)
+    ret.reserve(m_links.size());
+    for (const auto& [id, link] : m_links)
     {
-        ret.push_back(GetMinCw(linkId));
+        ret.push_back(link->cwMin);
     }
     return ret;
 }
@@ -429,9 +449,10 @@
 Txop::GetMaxCws() const
 {
     std::vector<uint32_t> ret;
-    for (std::size_t linkId = 0; linkId < m_links.size(); linkId++)
+    ret.reserve(m_links.size());
+    for (const auto& [id, link] : m_links)
     {
-        ret.push_back(GetMaxCw(linkId));
+        ret.push_back(link->cwMax);
     }
     return ret;
 }
@@ -452,9 +473,10 @@
 Txop::GetAifsns() const
 {
     std::vector<uint8_t> ret;
-    for (std::size_t linkId = 0; linkId < m_links.size(); linkId++)
+    ret.reserve(m_links.size());
+    for (const auto& [id, link] : m_links)
     {
-        ret.push_back(GetAifsn(linkId));
+        ret.push_back(link->aifsn);
     }
     return ret;
 }
@@ -475,9 +497,10 @@
 Txop::GetTxopLimits() const
 {
     std::vector<Time> ret;
-    for (std::size_t linkId = 0; linkId < m_links.size(); linkId++)
+    ret.reserve(m_links.size());
+    for (const auto& [id, link] : m_links)
     {
-        ret.push_back(GetTxopLimit(linkId));
+        ret.push_back(link->txopLimit);
     }
     return ret;
 }
@@ -548,10 +571,10 @@
 Txop::DoInitialize()
 {
     NS_LOG_FUNCTION(this);
-    for (std::size_t linkId = 0; linkId < m_links.size(); linkId++)
+    for (const auto& [id, link] : m_links)
     {
-        ResetCw(linkId);
-        GenerateBackoff(linkId);
+        ResetCw(id);
+        GenerateBackoff(id);
     }
 }
 
@@ -630,9 +653,9 @@
 Txop::NotifyOn()
 {
     NS_LOG_FUNCTION(this);
-    for (std::size_t linkId = 0; linkId < m_links.size(); linkId++)
+    for (const auto& [id, link] : m_links)
     {
-        StartAccessIfNeeded(linkId);
+        StartAccessIfNeeded(id);
     }
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/txop.h ns-3.40/src/wifi/model/txop.h
--- ns-3.39/src/wifi/model/txop.h	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/txop.h	2023-09-27 13:30:37.914839700 -0700
@@ -26,6 +26,7 @@
 #include "ns3/object.h"
 #include "ns3/traced-value.h"
 
+#include <map>
 #include <memory>
 #include <vector>
 
@@ -408,6 +409,16 @@
      */
     virtual bool HasFramesToTransmit(uint8_t linkId);
 
+    /**
+     * Swap the links based on the information included in the given map. This method
+     * is normally called by the WifiMac of a non-AP MLD upon completing ML setup to have
+     * its link IDs match AP MLD's link IDs.
+     *
+     * \param links a set of pairs (from, to) each mapping a current link ID to the
+     *              link ID it has to become (i.e., link 'from' becomes link 'to')
+     */
+    void SwapLinks(std::map<uint8_t, uint8_t> links);
+
   protected:
     ///< ChannelAccessManager associated class
     friend class ChannelAccessManager;
@@ -483,7 +494,6 @@
         /// Destructor (a virtual method is needed to make this struct polymorphic)
         virtual ~LinkEntity() = default;
 
-        uint8_t id{0};                             //!< Link ID (starting at 0)
         uint32_t backoffSlots{0};                  //!< the number of backoff slots
         Time backoffStart{0};                      /**< the backoffStart variable is used to keep
                                                         track of the time at which a backoff was
@@ -504,12 +514,11 @@
      * \return a reference to the link associated with the given ID
      */
     LinkEntity& GetLink(uint8_t linkId) const;
+
     /**
-     * Get the number of links.
-     *
-     * \return the number of links
+     * \return a const reference to the map of link entities
      */
-    uint8_t GetNLinks() const;
+    const std::map<uint8_t, std::unique_ptr<LinkEntity>>& GetLinks() const;
 
     DroppedMpdu m_droppedMpduCallback; //!< the dropped MPDU callback
     Ptr<WifiMacQueue> m_queue;         //!< the wifi MAC queue
@@ -533,7 +542,8 @@
      */
     virtual std::unique_ptr<LinkEntity> CreateLinkEntity() const;
 
-    std::vector<std::unique_ptr<LinkEntity>> m_links; //!< vector of LinkEntity objects
+    std::map<uint8_t, std::unique_ptr<LinkEntity>>
+        m_links; //!< ID-indexed map of LinkEntity objects
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/vht/vht-phy.cc ns-3.40/src/wifi/model/vht/vht-phy.cc
--- ns-3.39/src/wifi/model/vht/vht-phy.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/vht/vht-phy.cc	2023-09-27 13:30:37.914839700 -0700
@@ -314,7 +314,7 @@
 VhtPhy::ProcessSig(Ptr<Event> event, PhyFieldRxStatus status, WifiPpduField field)
 {
     NS_LOG_FUNCTION(this << *event << status << field);
-    NS_ASSERT(event->GetTxVector().GetPreambleType() >= WIFI_PREAMBLE_VHT_SU);
+    NS_ASSERT(event->GetPpdu()->GetTxVector().GetPreambleType() >= WIFI_PREAMBLE_VHT_SU);
     // TODO see if something should be done here once MU-MIMO is supported
     return status; // nothing special for VHT
 }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/vht/vht-ppdu.cc ns-3.40/src/wifi/model/vht/vht-ppdu.cc
--- ns-3.39/src/wifi/model/vht/vht-ppdu.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/vht/vht-ppdu.cc	2023-09-27 13:30:37.914839700 -0700
@@ -111,7 +111,7 @@
 Time
 VhtPpdu::GetTxDuration() const
 {
-    const WifiTxVector& txVector = GetTxVector();
+    const auto& txVector = GetTxVector();
     const auto length = m_lSig.GetLength();
     const auto sgi = m_vhtSig.GetShortGuardInterval();
     const auto sgiDisambiguation = m_vhtSig.GetShortGuardIntervalDisambiguation();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-assoc-manager.cc ns-3.40/src/wifi/model/wifi-assoc-manager.cc
--- ns-3.39/src/wifi/model/wifi-assoc-manager.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-assoc-manager.cc	2023-09-27 13:30:37.914839700 -0700
@@ -22,6 +22,9 @@
 
 #include "sta-wifi-mac.h"
 
+#include "ns3/attribute-container.h"
+#include "ns3/eht-configuration.h"
+#include "ns3/enum.h"
 #include "ns3/log.h"
 
 #include <algorithm>
@@ -65,7 +68,17 @@
 TypeId
 WifiAssocManager::GetTypeId()
 {
-    static TypeId tid = TypeId("ns3::WifiAssocManager").SetParent<Object>().SetGroupName("Wifi");
+    static TypeId tid =
+        TypeId("ns3::WifiAssocManager")
+            .SetParent<Object>()
+            .SetGroupName("Wifi")
+            .AddAttribute(
+                "AllowedLinks",
+                "Only Beacon and Probe Response frames received on a link belonging to the given "
+                "set are processed. An empty set is equivalent to the set of all links.",
+                AttributeContainerValue<UintegerValue>(),
+                MakeAttributeContainerAccessor<UintegerValue>(&WifiAssocManager::m_allowedLinks),
+                MakeAttributeContainerChecker<UintegerValue>(MakeUintegerChecker<uint8_t>()));
     return tid;
 }
 
@@ -164,10 +177,12 @@
     NS_LOG_FUNCTION(this);
     m_scanParams = std::move(scanParams);
 
-    // remove stored AP information not matching the scanning parameters
+    // remove stored AP information not matching the scanning parameters or related to APs
+    // that are not reachable on an allowed link
     for (auto ap = m_apList.begin(); ap != m_apList.end();)
     {
-        if (!MatchScanParams(*ap))
+        if (!MatchScanParams(*ap) ||
+            (!m_allowedLinks.empty() && m_allowedLinks.count(ap->m_linkId) == 0))
         {
             // remove AP info from list
             m_apListIt.erase(ap->m_bssid);
@@ -187,7 +202,8 @@
 {
     NS_LOG_FUNCTION(this << apInfo);
 
-    if (!CanBeInserted(apInfo) || !MatchScanParams(apInfo))
+    if (!CanBeInserted(apInfo) || !MatchScanParams(apInfo) ||
+        (!m_allowedLinks.empty() && m_allowedLinks.count(apInfo.m_linkId) == 0))
     {
         return;
     }
@@ -234,10 +250,10 @@
     m_mac->ScanningTimeout(std::move(bestAp));
 }
 
-std::list<std::pair<uint8_t, uint8_t>>&
+std::list<StaWifiMac::ApInfo::SetupLinksInfo>&
 WifiAssocManager::GetSetupLinks(const StaWifiMac::ApInfo& apInfo)
 {
-    return const_cast<std::list<std::pair<uint8_t, uint8_t>>&>(apInfo.m_setupLinks);
+    return const_cast<std::list<StaWifiMac::ApInfo::SetupLinksInfo>&>(apInfo.m_setupLinks);
 }
 
 bool
@@ -285,6 +301,26 @@
         return false;
     }
 
+    if (const auto& mldCapabilities = mle->get().GetCommonInfoBasic().m_mldCapabilities)
+    {
+        auto ehtConfig = m_mac->GetEhtConfiguration();
+        NS_ASSERT(ehtConfig);
+        EnumValue negSupport;
+        ehtConfig->GetAttributeFailSafe("TidToLinkMappingNegSupport", negSupport);
+
+        // A non-AP MLD that performs multi-link (re)setup on at least two links with an AP MLD
+        // that sets the TID-To-Link Mapping Negotiation Support subfield of the MLD Capabilities
+        // field of the Basic Multi-Link element to a nonzero value shall support TID-to-link
+        // mapping negotiation with the TID-To-Link Mapping Negotiation Support subfield of the
+        // MLD Capabilities field of the Basic Multi-Link element it transmits to at least 1.
+        // (Sec. 35.3.7.1.1 of 802.11be D3.1)
+        if (mldCapabilities->tidToLinkMappingSupport > 0 && negSupport.Get() == 0)
+        {
+            NS_LOG_DEBUG("AP MLD supports TID-to-Link Mapping negotiation, while we don't");
+            return false;
+        }
+    }
+
     return true;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-assoc-manager.h ns-3.40/src/wifi/model/wifi-assoc-manager.h
--- ns-3.39/src/wifi/model/wifi-assoc-manager.h	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-assoc-manager.h	2023-09-27 13:30:37.914839700 -0700
@@ -178,7 +178,7 @@
      * \param apInfo the info about the given AP
      * \return a reference to the list of the links to setup with the given AP
      */
-    std::list<std::pair<uint8_t, uint8_t>>& GetSetupLinks(const StaWifiMac::ApInfo& apInfo);
+    std::list<StaWifiMac::ApInfo::SetupLinksInfo>& GetSetupLinks(const StaWifiMac::ApInfo& apInfo);
 
     /**
      * \return the scanning parameters.
@@ -233,7 +233,9 @@
      */
     bool CanSetupMultiLink(OptMleConstRef& mle, OptRnrConstRef& rnr);
 
-    Ptr<StaWifiMac> m_mac; ///< pointer to the STA wifi MAC
+    Ptr<StaWifiMac> m_mac;            ///< pointer to the STA wifi MAC
+    std::set<uint8_t> m_allowedLinks; /**< "Only Beacon and Probe Response frames received on a
+                                            link belonging to the this set are processed */
 
   private:
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-bandwidth-filter.cc ns-3.40/src/wifi/model/wifi-bandwidth-filter.cc
--- ns-3.39/src/wifi/model/wifi-bandwidth-filter.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-bandwidth-filter.cc	2023-09-27 13:30:37.914839700 -0700
@@ -61,12 +61,17 @@
         return false;
     }
 
-    // WifiSpectrumPhyInterface (passed in) can be used to fetch SpectrumWifiPhy
-
     auto interface = DynamicCast<const WifiSpectrumPhyInterface>(receiverPhy);
-    auto wifiPhy = interface->GetSpectrumWifiPhy();
+    if (!interface)
+    {
+        NS_LOG_DEBUG("Sending a Wi-Fi signal to a non Wi-Fi device; do not filter");
+        return false;
+    }
 
-    NS_ASSERT_MSG(wifiPhy, "WifiPhy should be valid if WifiSpectrumSignalParameters was found");
+    auto wifiPhy = interface->GetSpectrumWifiPhy();
+    NS_ASSERT_MSG(wifiPhy,
+                  "WifiPhy should be valid if WifiSpectrumSignalParameters was found and sending "
+                  "to a WifiSpectrumPhyInterface");
 
     BooleanValue trackSignalsInactiveInterfaces;
     wifiPhy->GetAttribute("TrackSignalsFromInactiveInterfaces", trackSignalsInactiveInterfaces);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-default-assoc-manager.cc ns-3.40/src/wifi/model/wifi-default-assoc-manager.cc
--- ns-3.39/src/wifi/model/wifi-default-assoc-manager.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-default-assoc-manager.cc	2023-09-27 13:30:37.914839700 -0700
@@ -133,15 +133,12 @@
     }
 
     auto& bestAp = *GetSortedList().begin();
-
-    // store AP MLD MAC address in the WifiRemoteStationManager associated with
-    // the link on which the Beacon/Probe Response was received
-    m_mac->GetWifiRemoteStationManager(bestAp.m_linkId)
-        ->SetMldAddress(bestAp.m_apAddr, mle->get().GetMldMacAddress());
     auto& setupLinks = GetSetupLinks(bestAp);
 
     setupLinks.clear();
-    setupLinks.emplace_back(bestAp.m_linkId, mle->get().GetLinkIdInfo());
+    setupLinks.emplace_back(StaWifiMac::ApInfo::SetupLinksInfo{bestAp.m_linkId,
+                                                               mle->get().GetLinkIdInfo(),
+                                                               bestAp.m_bssid});
 
     // sort local PHY objects so that radios with constrained PHY band comes first,
     // then radios with no constraint
@@ -203,14 +200,10 @@
             // if we get here, it means we can setup a link with this affiliated AP
             // set the BSSID for this link
             Mac48Address bssid = rnr->get().GetBssid(apIt->m_nbrApInfoId, apIt->m_tbttInfoFieldId);
-            // store AP MLD MAC address in the WifiRemoteStationManager associated with
-            // the link requested to setup
-            m_mac->GetWifiRemoteStationManager(linkId)->SetMldAddress(
-                bssid,
-                mle->get().GetMldMacAddress());
-            setupLinks.emplace_back(
+            setupLinks.emplace_back(StaWifiMac::ApInfo::SetupLinksInfo{
                 linkId,
-                rnr->get().GetLinkId(apIt->m_nbrApInfoId, apIt->m_tbttInfoFieldId));
+                rnr->get().GetLinkId(apIt->m_nbrApInfoId, apIt->m_tbttInfoFieldId),
+                bssid});
 
             if (needChannelSwitch)
             {
@@ -264,12 +257,6 @@
         // we were waiting for this notification
         m_channelSwitchInfo[linkId].timer.Cancel();
 
-        // the remote station manager has been reset after switching, hence store
-        // information about AP link address and AP MLD address
-        m_mac->GetWifiRemoteStationManager(linkId)->SetMldAddress(
-            m_channelSwitchInfo[linkId].apLinkAddress,
-            m_channelSwitchInfo[linkId].apMldAddress);
-
         if (std::none_of(m_channelSwitchInfo.begin(), m_channelSwitchInfo.end(), [](auto&& info) {
                 return info.timer.IsRunning();
             }))
@@ -289,7 +276,7 @@
     auto& bestAp = *GetSortedList().begin();
     auto& setupLinks = GetSetupLinks(bestAp);
     auto it = std::find_if(setupLinks.begin(), setupLinks.end(), [&linkId](auto&& linkIds) {
-        return linkIds.first == linkId;
+        return linkIds.localLinkId == linkId;
     });
     NS_ASSERT(it != setupLinks.end());
     setupLinks.erase(it);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/wifi/model/wifi-default-protection-manager.cc ns-3.40/src/wifi/model/wifi-default-protection-manager.cc
--- ns-3.39/src/wifi/model/wifi-default-protection-manager.cc	2023-07-05 14:23:48.121428500 -0700
+++ ns-3.40/src/wifi/model/wifi-default-protection-manager.cc	2023-09-27 13:30:37.914839700 -0700
@@ -21,10 +21,12 @@
 
 #include "ap-wifi-mac.h"
 #include "frame-exchange-manager.h"
+#include "sta-wifi-mac.h"
 #include "wifi-mpdu.h"
 #include "wifi-tx-parameters.h"
 
 #include "ns3/boolean.h"
+#include "ns3/emlsr-manager.h"
 #include "ns3/erp-ofdm-phy.h"
 #include "ns3/log.h"
 
@@ -188,8 +190,20 @@
         return std::make_unique<WifiNoProtection>();
     }
 
+    // when an EMLSR client starts an UL TXOP on a link on which the main PHY is not operating,
+    // the aux PHY sends an RTS frame
+    bool emlsrNeedRts = false;
+
+    if (auto staMac = DynamicCast<StaWifiMac>(m_mac))
+    {
+        auto emlsrManager = staMac->GetEmlsrManager();
+
+        emlsrNeedRts = emlsrManager && staMac->IsEmlsrLink(m_linkId) &&
+                       m_mac->GetLinkForPhy(emlsrManager->GetMainPhyId()) != m_linkId;
+    }
+
     // check if RTS/CTS is needed
-    if (GetWifiRemoteStationManager()->NeedRts(hdr, size))
+    if (emlsrNeedRts || GetWifiRemoteStationManager()->NeedRts(hdr, size))
     {
         auto protection = std::make_unique<WifiRtsCtsProtection>();
         protection->rtsTxVector = GetWifiRemoteStationManager()->GetRtsTxVector(hdr.GetAddr1());
@@ -345,7 +359,6 @@
 
     NS_ABORT_MSG_IF(m_mac->GetTypeOfStation() != AP, "HE APs only can send DL MU PPDUs");
     const auto& staList = StaticCast<ApWifiMac>(m_mac)->GetStaList(m_linkId);
-    std::remove_reference_t<decltype(staList)>::const_iterator staIt;
 
     bool allProtected = true;
     bool isUnprotectedEmlsrDst = false;
@@ -355,7 +368,7 @@
         // Add a User Info field to the MU-RTS for this solicited station
         // The UL HE-MCS, UL FEC Coding Type, UL DCM, SS Allocation and UL Target RSSI fields
         // in the User Info field are reserved (Sec. 9.3.1.22.5 of 802.11ax)
-        staIt = staList.find(userInfo.GetAid12());
+        auto staIt = staList.find(userInfo.GetAid12());
         NS_ASSERT(staIt != staList.cend());
         AddUserInfoToMuRts(protection->muRts, txWidth, staIt->second);
         bool isProtected =
